//+------------------------------------------------------------------+
//|                                                  exp_cci_mt5.mq5 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#resource "\\Include\\Controls\\res\\CheckBoxOn.bmp"
#resource "\\Include\\Controls\\res\\CheckBoxOff.bmp"
#resource "\\Include\\Controls\\res\\CloseDisable.bmp"
#resource "\\Include\\Controls\\res\\Close.bmp"
#resource "\\Include\\Controls\\res\\RestoreDisable.bmp"
#resource "\\Include\\Controls\\res\\ExpandDisable.bmp"
#resource "\\Include\\Controls\\res\\TurnOn.bmp"
#resource "\\Include\\Controls\\res\\TurnOff.bmp"
#resource "\\Include\\Controls\\res\\down_smoll.bmp"
#resource "\\Include\\Controls\\res\\up_smoll.bmp"
#resource "\\Include\\Controls\\res\\DownSmall.bmp"
#resource "\\Include\\Controls\\res\\UpSmall.bmp"


string CheckBoxOn="::Include\\Controls\\res\\CheckBoxOn.bmp"; //     On
string CheckBoxOff="::Include\\Controls\\res\\CheckBoxOff.bmp";  //    
string CloseDisable="::Include\\Controls\\res\\CloseDisable.bmp"; //     On
string CloseOff="::Include\\Controls\\res\\Close.bmp";  //    
string RestoreDisable="::Include\\Controls\\res\\RestoreDisable.bmp"; //     On
string ExpandDisable="::Include\\Controls\\res\\ExpandDisable.bmp";  //    
string TurnOn="::Include\\Controls\\res\\TurnOn.bmp"; //     On
string TurnOff="::Include\\Controls\\res\\TurnOff.bmp";  //    

string down_smoll="::Include\\Controls\\res\\down_smoll.bmp"; //     On
string up_smoll="::Include\\Controls\\res\\up_smoll.bmp";  //    
string DownSmall="::Include\\Controls\\res\\DownSmall.bmp"; //     On
string UpSmall="::Include\\Controls\\res\\UpSmall.bmp";  //    

#include <strategy_cci.mqh>

input double Risk=1.0;
input double Ksl=1.0;
input double Ktp=2.0;
input int Period_CCI_S=100;
input int Period_CCI_F=13;
input int Period_ATR=21;
input ENUM_TIMEFRAMES TF_ATR=PERIOD_CURRENT;
input string CommentOrder="exp_cci";

int SymbolTotal;
int SymbolTotal2;
bool MarketWatch=true;
double _risk;
int Width;
int Height;
string form1="form1_";
string form2="form2_";
bool show_close=false;
bool show_roll = false;
bool show_turn = false;
bool show_ok=false;

ENUM_ORDER_TYPE Signal[];

MqlDateTime str1;
C_cci *cci[];
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- create timer
   EventSetMillisecondTimer(100);

   SymbolTotal=SymbolsTotal(MarketWatch);
   ArrayResize(cci,SymbolTotal);
   ArrayResize(Signal,SymbolTotal);
   _risk=Risk/(double)SymbolTotal;
   for(int i=0;i<SymbolTotal;i++)cci[i]=new C_cci(_risk,Ksl,Ktp,Period_CCI_S,Period_CCI_F,Period_ATR,TF_ATR,CommentOrder);

//     Width=ChartWidthInPixels()-20;
//Height=ChartHeightInPixelsGet();
//             from_create1();
//         from_create3();
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//--- destroy timer
   EventKillTimer();
   for(int i=0;i<SymbolTotal;i++)delete(cci[i]);
   ObjectsDeleteAll(0,form1);
   ObjectsDeleteAll(0,form2);

  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
//void OnTick()
//  {
////---
//
//  }
//+------------------------------------------------------------------+
//| Timer function                                                   |
//+------------------------------------------------------------------+
void OnTimer()
//void OnTick()
  {
   Width=ChartWidthInPixels()-20;
   Height=ChartHeightInPixelsGet()/2;

   if(SymbolTotal!=SymbolsTotal(MarketWatch))
     {
      ObjectsDeleteAll(0,form1);
      ObjectsDeleteAll(0,form2);
      for(int i=0;i<SymbolTotal;i++)delete(cci[i]);
      SymbolTotal=SymbolsTotal(MarketWatch);
      ArrayResize(cci,SymbolTotal);
      ArrayResize(Signal,SymbolTotal);
      _risk=Risk/(double)SymbolTotal;
      for(int i=0;i<SymbolTotal;i++)cci[i]=new C_cci(_risk,Ksl,Ktp,Period_CCI_S,Period_CCI_F,Period_ATR,TF_ATR,CommentOrder);
     }

   for(int i=0;i<SymbolTotal;i++)
     {
      cci[i].strategy_cci_mt5(SymbolName(i,MarketWatch));
     }
//---
   if(!show_turn || !show_roll)
     {
      from_create1();
      from_create3();
     }

   if(show_turn && !show_roll)
     {
      ObjectsDeleteAll(0,form1);
      ObjectsDeleteAll(0,form2);
      from_create2();
     }

   if(show_turn && show_roll)
     {
      ObjectsDeleteAll(0,form1);
      ObjectsDeleteAll(0,form2);
      from_create2();
     }

   if(show_roll)
     {
      ObjectsDeleteAll(0,form2);
     }

  }
//+------------------------------------------------------------------+
//| Trade function                                                   |
//+------------------------------------------------------------------+
//void OnTrade()
//  {
////---
//
//  }
////+------------------------------------------------------------------+
////| TradeTransaction function                                        |
////+------------------------------------------------------------------+
//void OnTradeTransaction(const MqlTradeTransaction &trans,
//                        const MqlTradeRequest &request,
//                        const MqlTradeResult &result)
//  {
////---
//
//  }
//+------------------------------------------------------------------+
//| ChartEvent function                                              |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
  {
//---

   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      if(sparam==form1+(string)1)
        {
         show_close=(int)ObjectGetInteger(0,form1+(string)1,OBJPROP_STATE);
         if(show_close)ExpertRemove();

        }

      if(sparam==form1+(string)3 || sparam==form1+(string)2)
        {
         show_turn=(int)ObjectGetInteger(0,form1+(string)3,OBJPROP_STATE);
         show_roll=(int)ObjectGetInteger(0,form1+(string)2,OBJPROP_STATE);

         if(!show_turn || !show_roll)
           {
            from_create1();
            from_create3();
           }

         if(show_turn && !show_roll)
           {
            ObjectsDeleteAll(0,form1);
            ObjectsDeleteAll(0,form2);
            from_create2();
           }

         if(show_turn && show_roll)
           {
            ObjectsDeleteAll(0,form1);
            ObjectsDeleteAll(0,form2);
            from_create2();
           }

         if(show_roll)
           {
            ObjectsDeleteAll(0,form2);
           }

        }

     }

  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void from_create1()
  {

   int i=0;
   int x = Width-20;
   int y = 0;


   RectLabelCreate(0,form1+(string)i,0,0,0,Width,20,clrDodgerBlue,BORDER_RAISED);i++;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,CloseOff,CloseDisable,0,0,0,0,show_close);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,RestoreDisable,ExpandDisable,0,0,0,0,show_roll);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y+2,TurnOff,TurnOn,0,0,0,0,show_turn);i++;x-=18;
   LabelCreate(0,form1+(string)i,0,15,2,TimeToString(TimeCurrent(),TIME_DATE|TIME_SECONDS)+" : "+DayOfWeekString(),10,clrBlack);i++;

  }
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
void from_create2()
  {

   int i=0;
   int x = 50;
   int y = 0;
   RectLabelCreate(0,form1+(string)i,0,10,0,60,20,clrDodgerBlue,BORDER_RAISED);i++;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,CloseOff,CloseDisable,0,0,0,0,show_close);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y,ExpandDisable,RestoreDisable,0,0,0,0,show_roll);i++;x-=18;
   BitmapLabelCreate(0,form1+(string)i,0,x,y+2,TurnOff,TurnOn,0,0,0,0,show_turn);i++;x-=18;
  }
//+------------------------------------------------------------------+
void from_create3()
  {
   int i=10;
   int x = 5;
   int y = 25;



   RectLabelCreate(0,form2+(string)i,0,0,20,Width,Height,clrWhiteSmoke,BORDER_SUNKEN);i++;

   for(int n=0;n<SymbolTotal;n++)
     {
      //if(!IsVisualMode() && !MarketInfo(SymbolName(n,MarketWatch),MODE_TRADEALLOWED))continue;
      //if(IsVisualMode()){LabelCreate(0,form2+(string)i,0,x,y,_Symbol,10,clrBlack);i++;}
      LabelCreate(0,form2+(string)i,0,x,y,SymbolName(n,MarketWatch),10,clrBlack);i++;
      LabelCreate(0,form2+(string)i,0,x+60,y,":",10,clrBlack);i++;
      LabelCreate(0,form2+(string)i,0,x+100,y,CharToString((uchar)cci[n].arrow(cci[n].trend)),10,cci[n].colorarrow(cci[n].trend),"Wingdings");i++;

      LabelCreate(0,form2+(string)i,0,x+120,y,":",10,clrBlack);i++;
      LabelCreate(0,form2+(string)i,0,x+170,y,CharToString((uchar)cci[n].arrow(cci[n].signal)),10,cci[n].colorarrow(cci[n].signal),"Wingdings");i++;

      y+=15;
      if(y>=Height-20)
        {
         x+=200;
         y=25;
        }
     }

  }
//+------------------------------------------------------------------+
//int arrow(ENUM_ORDER_TYPE sig)
//  {
//   if(sig==WRONG_VALUE)return(251);
//   if(sig==ORDER_TYPE_BUY)return(233);
//   if(sig==ORDER_TYPE_SELL)return(234);
//   return(0);
//  }
////+------------------------------------------------------------------+
////+------------------------------------------------------------------+
//int Colorarrow(ENUM_ORDER_TYPE sig)
//  {
//   if(sig==WRONG_VALUE)return(clrMediumAquamarine);
//   if(sig==ORDER_TYPE_BUY)return(clrBlue);
//   if(sig==ORDER_TYPE_SELL)return(clrRed);
//   return(0);
//  }
//+------------------------------------------------------------------+
string  DayOfWeekString()
  {
   TimeToStruct(TimeCurrent(),str1);
   switch(str1.day_of_week)
     {
      case 0: return("");
      case 1: return("");
      case 2: return("");
      case 3: return("");
      case 4: return("");
      case 5: return("");
      case 6: return("");
     }
   return(NULL);
  }
//+------------------------------------------------------------------+
bool ButtonCreate(const long              chart_ID=0,// ID 
                  const string            name="Button",            //  
                  const int               sub_window=0,             //  
                  const int               x=0,                      //    X
                  const int               y=0,                      //    Y
                  const int               width=50,                 //  
                  const int               height=18,                //  
                  const string            text="Button",            // 
                  const int               font_size=10,             //  
                  const bool              state=false,              // /
                  const color             clr=clrBlack,             //  
                  const color             back_clr=C'236,233,216',  //  
                  const color             border_clr=clrNONE,       //  
                  const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //                     
                  const string            font="Arial",             //                  
                  const bool              back=false,               //   
                  const bool              selection=false,          //   
                  const bool              hidden=true,              //    
                  const long              z_order=0)                //    
  {
//---   
   ResetLastError();
//---  
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_BUTTON,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---     
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
bool RectLabelCreate(const long             chart_ID=0,// ID 
                     const string           name="RectLabel",         //  
                     const int              sub_window=0,             //  
                     const int              x=0,                      //    X
                     const int              y=0,                      //    Y
                     const int              width=50,                 // 
                     const int              height=18,                // 
                     const color            back_clr=C'236,233,216',  //  
                     const ENUM_BORDER_TYPE border=BORDER_SUNKEN,     //  
                     const color            clr=clrRed,               //    (Flat)
                     const int              line_width=1,             //   
                     const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, //    

                     const ENUM_LINE_STYLE  style=STYLE_SOLID,//   

                     const bool             back=false,               //   
                     const bool             selection=false,          //   
                     const bool             hidden=true,              //    
                     const long             z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_RECTANGLE_LABEL,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_TYPE,border);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---     (  Flat)
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---     
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//---    
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,line_width);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
bool BitmapLabelCreate(const long              chart_ID=0,// ID 
                       const string            name="BmpLabel",          //  
                       const int               sub_window=0,             //  
                       const int               x=0,                      //    X
                       const int               y=0,                      //    Y
                       const string            file_on="",               //    On
                       const string            file_off="",              //    Off
                       const int               width=0,                  // X-  
                       const int               height=0,                 // Y-  
                       const int               x_offset=10,              //     X
                       const int               y_offset=10,              //     Y
                       const bool              state=false,              // /
                       const color             clr=clrRed,               //    
                       const int               point_width=1,            //   
                       const ENUM_LINE_STYLE   style=STYLE_SOLID,        //    
                       const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //    
                       const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //                        

                       const bool              back=false,               //   
                       const bool              selection=false,          //   
                       const bool              hidden=true,              //    
                       const long              z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_BITMAP_LABEL,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---     On  Off
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,0,file_on))
     {
      Print(__FUNCTION__,
            ":  Error Code = ",GetLastError());
      return(false);
     }
   if(!ObjectSetString(chart_ID,name,OBJPROP_BMPFILE,1,file_off))
     {
      Print(__FUNCTION__,
            ": Error Code = ",GetLastError());
      return(false);
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---    ;     
//---      ()  , 
//---   ;        ,
//---     ,    
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//--- ,        
//---       ;  
//---          
   ObjectSetInteger(chart_ID,name,OBJPROP_XOFFSET,x_offset);
   ObjectSetInteger(chart_ID,name,OBJPROP_YOFFSET,y_offset);
//--- ,      (  )
   ObjectSetInteger(chart_ID,name,OBJPROP_STATE,state);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//---        
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_STYLE,style);
//---    ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_WIDTH,point_width);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
bool EditCreate(const long             chart_ID=0,// ID 
                const string           name="Edit",              //  
                const int              sub_window=0,             //  
                const int              x=0,                      //    X
                const int              y=0,                      //    Y
                const int              width=50,                 // 
                const int              height=18,                // 
                const string           text="Text",              // 
                const int              font_size=10,             //                  
                const color            clr=clrBlack,             //  
                const color            back_clr=clrWhite,        //  
                const ENUM_ALIGN_MODE  align=ALIGN_LEFT,//   
                const bool             read_only=true,//  
                const color            border_clr=clrNONE,       //  
                const ENUM_BASE_CORNER corner=CORNER_LEFT_UPPER, //    
                const string           font="Arial",             // 
                const bool             back=false,               //   
                const bool             selection=false,          //   
                const bool             hidden=true,              //    
                const long             z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_EDIT,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XSIZE,width);
   ObjectSetInteger(chart_ID,name,OBJPROP_YSIZE,height);
//---  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---      
   ObjectSetInteger(chart_ID,name,OBJPROP_ALIGN,align);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_READONLY,read_only);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BGCOLOR,back_clr);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_BORDER_COLOR,border_clr);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
bool LabelCreate(const long              chart_ID=0,// ID 
                 const string            name="Label",             //  
                 const int               sub_window=0,             //  
                 const int               x=0,                      //    X
                 const int               y=0,                      //    Y
                 const string            text="Label",             // 
                 const int               font_size=10,             //  
                 const color             clr=clrRed,               // 
                 const string            font="Arial",             //  
                 const ENUM_BASE_CORNER  corner=CORNER_LEFT_UPPER, //     
                 const ENUM_ANCHOR_POINT anchor=ANCHOR_LEFT_UPPER, //                                                                  
                 const double            angle=0.0,                //                   
                 const bool              back=false,               //   
                 const bool              selection=false,          //   
                 const bool              hidden=true,              //    
                 const long              z_order=0)                //    
  {
//---   
   ResetLastError();
//---   
   if(ObjectFind(chart_ID,name)!=sub_window)
     {
      if(!ObjectCreate(chart_ID,name,OBJ_LABEL,sub_window,0,0))
        {
         Print(__FUNCTION__,
               ": Error Code = ",GetLastError());
         return(false);
        }
     }
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_XDISTANCE,x);
   ObjectSetInteger(chart_ID,name,OBJPROP_YDISTANCE,y);
//---   ,      
   ObjectSetInteger(chart_ID,name,OBJPROP_CORNER,corner);
//---  
   ObjectSetString(chart_ID,name,OBJPROP_TEXT,text);
//---   
   ObjectSetString(chart_ID,name,OBJPROP_FONT,font);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_FONTSIZE,font_size);
//---    
   ObjectSetDouble(chart_ID,name,OBJPROP_ANGLE,angle);
//---   
   ObjectSetInteger(chart_ID,name,OBJPROP_ANCHOR,anchor);
//---  
   ObjectSetInteger(chart_ID,name,OBJPROP_COLOR,clr);
//---    (false)   (true) 
   ObjectSetInteger(chart_ID,name,OBJPROP_BACK,back);
//---  (true)   (false)    
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTABLE,selection);
   ObjectSetInteger(chart_ID,name,OBJPROP_SELECTED,selection);
//---  (true)   (false)      
   ObjectSetInteger(chart_ID,name,OBJPROP_HIDDEN,hidden);
//---         
   ObjectSetInteger(chart_ID,name,OBJPROP_ZORDER,z_order);
//---  
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|       .             |
//+------------------------------------------------------------------+
int ChartWidthInPixels(const long chart_ID=0)
  {
//---      
   long result=-1;
//---   
   ResetLastError();
//---   
   if(!ChartGetInteger(chart_ID,CHART_WIDTH_IN_PIXELS,0,result))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//---    
   return((int)result);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|       .             |
//+------------------------------------------------------------------+
int ChartHeightInPixelsGet(const long chart_ID=0,const int sub_window=0)
  {
//---      
   long result=-1;
//---   
   ResetLastError();
//---   
   if(!ChartGetInteger(chart_ID,CHART_HEIGHT_IN_PIXELS,sub_window,result))
     {
      //---       ""
      Print(__FUNCTION__+", Error Code = ",GetLastError());
     }
//---    
   return((int)result);
  }
//+------------------------------------------------------------------+
